﻿using Hotline.CallCenter.Tels;
using Hotline.Share.Dtos.Users;

namespace Hotline.Users
{
    public interface IUserDomainService
    {
        /// <summary>
        /// 上班
        /// </summary>
        /// <param name="userId">userId</param>
        /// <param name="tel"></param>
        /// <param name="cancellationToken"></param>
        /// <returns></returns>
        Task OnDutyAsync(string userId, Tel tel, CancellationToken cancellationToken);

        /// <summary>
        /// 下班
        /// </summary>
        /// <param name="userId"></param>
        /// <param name="cancellationToken"></param>
        /// <returns></returns>
        Task<WorkDto?> OffDutyAsync(string userId, CancellationToken cancellationToken);

        Task<User?> GetUserAsync(string userId, CancellationToken cancellationToken);

        /// <summary>
        /// 查询用户包含部门信息
        /// </summary>
        /// <param name="userIds"></param>
        /// <param name="cancellationToken"></param>
        /// <returns></returns>
        Task<IReadOnlyList<User>> QueryWithOrgsAsync(IEnumerable<string> userIds, CancellationToken cancellationToken);
    }
}
